#include "json.hpp"

String Myjson::create_json_string(volatile DataStruct *data_struct, size_t nr_dataobjects, PIDStruct *pid_struct, time_t runtime_s)
{
    static unsigned long last_send_ms = 0; 
    unsigned int _sections = nr_dataobjects;                 //number of different values
    const unsigned int _sec_objects = NR_JSON_SECTION_OBJECTS;     //number of objects per value
    const unsigned int _obj_members = 5 + 14;                      //number of members per object
    String json_str = "";

    int _capacity = JSON_ARRAY_SIZE(_sections) + _sec_objects*JSON_OBJECT_SIZE(_obj_members);
    DynamicJsonDocument _doc(_capacity + 100);
    _doc["runtime_s"] = runtime_s;

    JsonObject _doc_object[_sections + 1];
    _doc_object[0] = _doc.createNestedObject("PIDparams");
    _doc_object[0]["goal_speed"]=pid_struct->speed;
    _doc_object[0]["current_speed"]=pid_struct->current_speed;
    _doc_object[0]["err"]=pid_struct->err;
    _doc_object[0]["integrative"]=pid_struct->integ;
    _doc_object[0]["derivative"]=pid_struct->derivative;
    _doc_object[0]["output"]=pid_struct->output;
    _doc_object[0]["esc_output"]=pid_struct->esc_output;
    _doc_object[0]["weigth_proportional"]=pid_struct->kp;
    _doc_object[0]["weigth_integrational"]=pid_struct->ki;
    _doc_object[0]["weigth_differential"]=pid_struct->kd;
    _doc_object[0]["min_speed"]=pid_struct->min_speed;
    _doc_object[0]["max_speed"]=pid_struct->max_speed;
    _doc_object[0]["timestamp"]=pid_struct->timestamp;        
    
    for(unsigned int section_nr = 1; section_nr < _sections; section_nr++)
    {   
        _doc_object[section_nr] = _doc.createNestedObject(data_struct[section_nr].name);
        _doc_object[section_nr]["ticks"] = data_struct[section_nr].ticks;        
        _doc_object[section_nr]["value"] = data_struct[section_nr].value;
        _doc_object[section_nr]["unit"] = data_struct[section_nr].unit;
        _doc_object[section_nr]["timestamp"] = data_struct[section_nr].timestamp;
    }

    int nr_bytes = serializeJson(_doc, json_str);

    return(json_str);

}